#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

typedef struct {
    char nume[21];
    int cantitate;
}fruct;

void decodifica(char *cuv, fruct *x)
{
    int ls=strlen(cuv);
    x->cantitate=0;
    int idx_nume=0;
    for (int i=0; i<ls; i++)
    {
        if (isdigit(cuv[i]))
            x->cantitate =  x->cantitate*10 + cuv[i]-'0';
        else
        {
            x->nume[idx_nume]=cuv[i];
            idx_nume++;
        }
    }
    x->nume[idx_nume]='\0';
}

void citeste_si_calculeaza(char * nume_fis, fruct* t, int* n)
{
    FILE *pf = fopen(nume_fis,"r");
    if (pf==NULL)
    {
        printf("Nu se pot citi fructele!!!");
        exit(1);
    }

    *n=0;
    char cuv[30];
    while (fscanf(pf,"%s",cuv)==1)
    {
        fruct f;
        decodifica(cuv,&f);

        int gasit=0;
        for (int i=0; i<*n; i++)
            if (strcmp(t[i].nume,f.nume)==0)
            {
                t[i].cantitate += f.cantitate;
                gasit=1;
                break;
            }

        if (!gasit)
        {
            t[*n]=f;
            (*n)++;
        }
    }

    fclose(pf);
}

void scrie_text(fruct *t, int n,char *nume_fis)
{
    FILE *pf = fopen(nume_fis,"w");
    if (pf==NULL)
    {
        printf("Nu se pot scrie rezultatele text!!!");
        return;
    }
    for(int i=0; i<n; i++)
        fprintf(pf,"%s %d\n",t[i].nume, t[i].cantitate); // (t+i)->nume

    fclose(pf);
}

void scrie_binar(fruct *t, int n,char *nume_fis)
{
    FILE *pf = fopen(nume_fis,"wb");
    if (pf==NULL)
    {
        printf("Nu se pot scrie rezultatele binar!!!");
        return;
    }
    fwrite(t,sizeof(fruct),n,pf);

    fclose(pf);
}

int main()
{
    fruct t[100];
    int n;
    citeste_si_calculeaza("fructe.txt",t,&n);
    scrie_text(t,n,"inventar.txt");
    scrie_binar(t,n,"inventar.bin");
    return 0;
}
