#include <stdio.h>
#include <string.h>
#include <stdlib.h>

typedef struct {
    char nume[21];
    int cantitate;
}fruct;

void decodifica(char *cuvant, fruct *f)
{
     int lcuv = strlen(cuvant);
     f->cantitate=0;
     int k=0;
     for (int i=0; i<lcuv; i++)
        if (cuvant[i]>='0' && cuvant[i]<='9')
        {
            f->cantitate = f->cantitate*10 + cuvant[i]-'0';
        } else {
            f->nume[k] = cuvant[i];
            k++;
        }
    f->nume[k]='\0';
}

void citeste_si_calculeaza_inventar(char *nume_fis, fruct *a, int *n)
{
    FILE *pf = fopen(nume_fis,"r");
    if (pf == NULL)
    {
        printf("Eroare - fisier intrare!");
        exit(10);
    }


    char cuvant[30];
    *n=0;
    while (fscanf(pf,"%s",cuvant)==1)
    {
        fruct f;
        decodifica(cuvant,&f);

        int gasit=0;
        for (int i=0; i<*n; i++)
            if (strcmp(f.nume, a[i].nume)==0)
            {
                gasit=1;
                a[i].cantitate += f.cantitate;
                break;
            }

        if (!gasit)
        {
            a[*n]=f;
            (*n)++;
        }
    }

    fclose(pf);
}

void scrie_rezultate_text(char *nume_fis, fruct *a, int na)
{
    FILE *pf = fopen(nume_fis,"w");
    if (pf == NULL)
    {
        printf("Eroare - fisier text iesire!");
        return;
    }

    for (int i=0; i<na; i++)
        fprintf(pf,"%s %d\n", a[i].nume, a[i].cantitate);

    fclose(pf);
}

void scrie_rezultate_binar(char *nume_fis, fruct *a, int na)
{
    FILE *pf = fopen(nume_fis,"wb");
    if (pf == NULL)
    {
        printf("Eroare - fisier binar iesire!");
        return;
    }

    fwrite(a,sizeof(fruct),na,pf);

    fclose(pf);
}

int main()
{
    fruct a[100];
    int na;
    citeste_si_calculeaza_inventar("fructe.txt",a,&na);
    scrie_rezultate_text("inventar.txt",a,na);
    scrie_rezultate_binar("inventar.bin",a,na);
    return 0;
}
